## bowtie2 2.0.0

=== Makefile ===
#
# Copyright 2011, Ben Langmead <blangmea@jhsph.edu>
#
# This file is part of Bowtie 2.
#
# Bowtie 2 is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Bowtie 2 is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Bowtie 2.  If not, see <http://www.gnu.org/licenses/>.
#

#
# Makefile for bowtie, bowtie2-build, bowtie2-inspect
#

INC =
GCC_PREFIX = $(shell dirname `which gcc`)
GCC_SUFFIX =
CC = $(GCC_PREFIX)/gcc$(GCC_SUFFIX)
CPP = $(GCC_PREFIX)/g++$(GCC_SUFFIX)
CXX = $(CPP)
HEADERS = $(wildcard *.h)
BOWTIE_PTHREADS = 1
BOWTIE_MM = 1
BOWTIE_SHARED_MEM = 0

# Detect Cygwin or MinGW
WINDOWS = 0
ifneq (,$(findstring CYGWIN,$(shell uname)))
WINDOWS = 1
# POSIX memory-mapped files not currently supported on Windows
BOWTIE_MM = 0
BOWTIE_SHARED_MEM = 0
else
ifneq (,$(findstring MINGW,$(shell uname)))
WINDOWS = 1
# POSIX memory-mapped files not currently supported on Windows
BOWTIE_MM = 0
BOWTIE_SHARED_MEM = 0
endif
endif

MACOS = 0
ifneq (,$(findstring Darwin,$(shell uname)))
MACOS = 1
endif

MM_DEF = 
ifeq (1,$(BOWTIE_MM))
MM_DEF = -DBOWTIE_MM
endif
SHMEM_DEF = 
ifeq (1,$(BOWTIE_SHARED_MEM))
SHMEM_DEF = -DBOWTIE_SHARED_MEM
endif
PTHREAD_PKG =
PTHREAD_LIB =
PTHREAD_DEF =
ifeq (1,$(BOWTIE_PTHREADS))
PTHREAD_DEF = -DBOWTIE_PTHREADS
ifeq (1,$(WINDOWS))
# pthreads for windows forces us to be specific about the library
PTHREAD_LIB = -lpthreadGC2
PTHREAD_PKG = pthreadGC2.dll
else
# There's also -pthread, but that only seems to work on Linux
PTHREAD_LIB = -lpthread
endif
endif

PREFETCH_LOCALITY = 2
PREF_DEF = -DPREFETCH_LOCALITY=$(PREFETCH_LOCALITY)

LIBS = 
SEARCH_LIBS = $(PTHREAD_LIB)
BUILD_LIBS =

SHARED_CPPS = ccnt_lut.cpp ref_read.cpp alphabet.cpp shmem.cpp \
              edit.cpp bt2_idx.cpp bt2_io.cpp bt2_util.cpp \
              reference.cpp ds.cpp multikey_qsort.cpp limit.cpp
SEARCH_CPPS = qual.cpp pat.cpp sam.cpp \
              read_qseq.cpp aligner_seed_policy.cpp \
              aligner_seed.cpp aligner_sw.cpp \
			  aligner_sw_driver.cpp aligner_cache.cpp \
			  aligner_result.cpp ref_coord.cpp mask.cpp \
			  pe.cpp aln_sink.cpp dp_framer.cpp \
			  scoring.cpp presets.cpp unique.cpp \
			  aligner_bt.cpp sse_util.cpp \
			  aligner_swsse.cpp outq.cpp \
			  aligner_swsse_loc_i16.cpp \
			  aligner_swsse_ee_i16.cpp \
			  aligner_swsse_loc_u8.cpp \
			  aligner_swsse_ee_u8.cpp
SEARCH_CPPS_MAIN = $(SEARCH_CPPS) bowtie_main.cpp

BUILD_CPPS = diff_sample.cpp
BUILD_CPPS_MAIN = $(BUILD_CPPS) bowtie_build_main.cpp

SEARCH_FRAGMENTS = $(wildcard search_*_phase*.c)
VERSION = $(shell cat VERSION)
EXTRA_FLAGS =

# Convert BITS=?? to a -m flag
BITS=32
ifeq (x86_64,$(shell uname -m))
BITS=64
endif
BITS_FLAG =
ifeq (32,$(BITS))
BITS_FLAG = -m32
endif
ifeq (64,$(BITS))
BITS_FLAG = -m64
endif

SSE_FLAG=-msse2

DEBUG_FLAGS    = -O0 -g3 $(BITS_FLAG) $(SSE_FLAG)
DEBUG_DEFS     = -DCOMPILER_OPTIONS="\"$(DEBUG_FLAGS) $(EXTRA_FLAGS)\""
RELEASE_FLAGS  = -O3 $(BITS_FLAG) $(SSE_FLAG) -funroll-loops -g3
RELEASE_DEFS   = -DCOMPILER_OPTIONS="\"$(RELEASE_FLAGS) $(EXTRA_FLAGS)\""
NOASSERT_FLAGS = -DNDEBUG
FILE_FLAGS     = -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64 -D_GNU_SOURCE

BOWTIE2_BIN_LIST =     bowtie2-build \
                       bowtie2-align \
                       bowtie2-inspect
BOWTIE2_BIN_LIST_AUX = bowtie2-build-debug \
                       bowtie2-align-debug \
                       bowtie2-inspect-debug

GENERAL_LIST = $(wildcard scripts/*.sh) \
               $(wildcard scripts/*.pl) \
               doc/manual.html \
               doc/README \
               doc/style.css \
			   $(wildcard example/index/*.bt2) \
			   $(wildcard example/reads/*.fq) \
			   $(wildcard example/reads/*.pl) \
			   example/reference/lambda_virus.fa \
               $(PTHREAD_PKG) \
			   bowtie2 \
               AUTHORS \
               COPYING \
               NEWS \
               MANUAL \
               MANUAL.markdown \
               TUTORIAL \
               VERSION

# This is helpful on Windows under MinGW/MSYS, where Make might go for
# the Windows FIND tool instead.
FIND=$(shell which find)

SRC_PKG_LIST = $(wildcard *.h) \
               $(wildcard *.hh) \
               $(wildcard *.c) \
               $(wildcard *.cpp) \
               doc/strip_markdown.pl \
               Makefile \
               $(GENERAL_LIST)

BIN_PKG_LIST = $(GENERAL_LIST)

.PHONY: all allall both both-debug

all: $(BOWTIE2_BIN_LIST)

allall: $(BOWTIE2_BIN_LIST) $(BOWTIE2_BIN_LIST_AUX)

both: bowtie2 bowtie2-build

both-debug: bowtie2-align-debug bowtie2-build-debug

DEFS=-fno-strict-aliasing \
     -DBOWTIE2_VERSION="\"`cat VERSION`\"" \
     -DBUILD_HOST="\"`hostname`\"" \
     -DBUILD_TIME="\"`date`\"" \
     -DCOMPILER_VERSION="\"`$(CXX) -v 2>&1 | tail -1`\"" \
     $(FILE_FLAGS) \
     $(PTHREAD_DEF) \
     $(PREF_DEF) \
     $(MM_DEF) \
     $(SHMEM_DEF)

#
# bowtie2-build targets
#

bowtie2-build: bt2_build.cpp $(SHARED_CPPS) $(HEADERS)
	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(EXTRA_FLAGS) \
		$(DEFS) -DBOWTIE2 $(NOASSERT_FLAGS) -Wall \
		$(INC) \
		-o $@ $< \
		$(SHARED_CPPS) $(BUILD_CPPS_MAIN) \
		$(LIBS) $(BUILD_LIBS)

bowtie2-build-debug: bt2_build.cpp $(SHARED_CPPS) $(HEADERS)
	$(CXX) $(DEBUG_FLAGS) $(DEBUG_DEFS) $(EXTRA_FLAGS) \
		$(DEFS) -DBOWTIE2 -Wall \
		$(INC) \
		-o $@ $< \
		$(SHARED_CPPS) $(BUILD_CPPS_MAIN) \
		$(LIBS) $(BUILD_LIBS)

#
# bowtie targets
#

bowtie2-align: bt2_search.cpp $(SEARCH_CPPS) $(SHARED_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(EXTRA_FLAGS) \
		$(DEFS) -DBOWTIE2 $(NOASSERT_FLAGS) -Wall \
		$(INC) \
		-o $@ $< \
		$(SHARED_CPPS) $(SEARCH_CPPS_MAIN) \
		$(LIBS) $(SEARCH_LIBS)

bowtie2-align-debug: bt2_search.cpp $(SEARCH_CPPS) $(SHARED_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
	$(CXX) $(DEBUG_FLAGS) \
		$(DEBUG_DEFS) $(EXTRA_FLAGS) \
		$(DEFS) -DBOWTIE2 -Wall \
		$(INC) \
		-o $@ $< \
		$(SHARED_CPPS) $(SEARCH_CPPS_MAIN) \
		$(LIBS) $(SEARCH_LIBS)

#
# bowtie2-inspect targets
#

bowtie2-inspect: bt2_inspect.cpp $(HEADERS) $(SHARED_CPPS)
	$(CXX) $(RELEASE_FLAGS) \
		$(RELEASE_DEFS) $(EXTRA_FLAGS) \
		$(DEFS) -DBOWTIE2 -DBOWTIE_INSPECT_MAIN -Wall \
		$(INC) -I . \
		-o $@ $< \
		$(SHARED_CPPS) \
		$(LIBS)

bowtie2-inspect-debug: bt2_inspect.cpp $(HEADERS) $(SHARED_CPPS) 
	$(CXX) $(DEBUG_FLAGS) \
		$(DEBUG_DEFS) $(EXTRA_FLAGS) \
		$(DEFS) -DBOWTIE2 -DBOWTIE_INSPECT_MAIN -Wall \
		$(INC) -I . \
		-o $@ $< \
		$(SHARED_CPPS) \
		$(LIBS)

.PHONY: bowtie2-src
bowtie2-src: $(SRC_PKG_LIST)
	chmod a+x scripts/*.sh scripts/*.pl
	mkdir .src.tmp
	mkdir .src.tmp/bowtie2-$(VERSION)
	zip tmp.zip $(SRC_PKG_LIST)
	mv tmp.zip .src.tmp/bowtie2-$(VERSION)
	cd .src.tmp/bowtie2-$(VERSION) ; unzip tmp.zip ; rm -f tmp.zip
	cd .src.tmp ; zip -r bowtie2-$(VERSION)-source.zip bowtie2-$(VERSION)
	cp .src.tmp/bowtie2-$(VERSION)-source.zip .
	rm -rf .src.tmp

.PHONY: bowtie2-bin
bowtie2-bin: $(BIN_PKG_LIST) $(BOWTIE2_BIN_LIST) $(BOWTIE2_BIN_LIST_AUX) 
	chmod a+x scripts/*.sh scripts/*.pl
	rm -rf .bin.tmp
	mkdir .bin.tmp
	mkdir .bin.tmp/bowtie2-$(VERSION)
	if [ -f bowtie.exe ] ; then \
		zip tmp.zip $(BIN_PKG_LIST) $(addsuffix .exe,$(BOWTIE2_BIN_LIST) $(BOWTIE2_BIN_LIST_AUX)) ; \
	else \
		zip tmp.zip $(BIN_PKG_LIST) $(BOWTIE2_BIN_LIST) $(BOWTIE2_BIN_LIST_AUX) ; \
	fi
	mv tmp.zip .bin.tmp/bowtie2-$(VERSION)
	cd .bin.tmp/bowtie2-$(VERSION) ; unzip tmp.zip ; rm -f tmp.zip
	cd .bin.tmp ; zip -r bowtie2-$(VERSION)-$(BITS).zip bowtie2-$(VERSION)
	cp .bin.tmp/bowtie2-$(VERSION)-$(BITS).zip .
	rm -rf .bin.tmp

bowtie2-seeds-debug: aligner_seed.cpp ccnt_lut.cpp alphabet.cpp aligner_seed.h bt2_idx.cpp bt2_io.cpp
	$(CXX) $(DEBUG_FLAGS) \
		$(DEBUG_DEFS) $(EXTRA_FLAGS) \
		-DSCAN_MAIN \
		$(DEFS) -Wall \
		$(INC) -I . \
		-o $@ $< \
		aligner_seed.cpp bt2_idx.cpp ccnt_lut.cpp alphabet.cpp bt2_io.cpp \
		$(LIBS)

.PHONY: doc
doc: doc/manual.html MANUAL

doc/manual.html: MANUAL.markdown
	echo "<h1>Table of Contents</h1>" > .tmp.head
	pandoc -T "Bowtie 2 Manual" -B .tmp.head \
	       --css style.css -o $@ \
	       --from markdown --to HTML \
	       --table-of-contents $^

MANUAL: MANUAL.markdown
	perl doc/strip_markdown.pl < $^ > $@

.PHONY: clean
clean:
	rm -f $(BOWTIE2_BIN_LIST) $(BOWTIE2_BIN_LIST_AUX) \
	$(addsuffix .exe,$(BOWTIE2_BIN_LIST) $(BOWTIE2_BIN_LIST_AUX)) \
	bowtie2-src.zip bowtie2-bin.zip
	rm -f core.* .tmp.head
	rm -rf *.dSYM

## bowtie2 2.0.0-beta5

=== debian/changelog ===
bowtie2 (2.0.0-beta5-1) unstable; urgency=low

  [ Alexandre Mestiashvili ]
  * Initial release (Closes: #660762)

 -- Alexandre Mestiashvili <alex@biotec.tu-dresden.de>  Wed, 22 Feb 2012 11:03:03 +0100

=== debian/control ===
Source: bowtie2
Section: science
Priority: extra
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
DM-Upload-Allowed: yes
Uploaders: Alexandre Mestiashvili <alex@biotec.tu-dresden.de>
Build-Depends: debhelper (>= 8.0), help2man
Standards-Version: 3.9.2
Homepage: http://bowtie-bio.sourceforge.net/bowtie2
Vcs-Browser: http://git.debian.org/?p=debian-med/bowtie2.git
Vcs-Git: git://git.debian.org/debian-med/bowtie2.git

Package: bowtie2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: bowtie2-examples
Description: ultrafast memory-efficient short read aligner
 is an ultrafast and memory-efficient tool for aligning sequencing reads 
 to long reference sequences. It is particularly good at aligning reads 
 of about 50 up to 100s or 1,000s of characters, and particularly good 
 at aligning to relatively long (e.g. mammalian) genomes. 
 .
 Bowtie 2 indexes the genome with an FM Index to keep its memory footprint
 small: for the human genome, its memory footprint is typically 
 around 3.2 GB. Bowtie 2 supports gapped, local, and paired-end alignment modes

Package: bowtie2-examples
Architecture: all
Depends: ${misc:Depends}
Recommends: bowtie2
Enhances: bowtie2
Description: Examples for bowtie2, 
 an ultrafast and memory-efficient tool for aligning sequencing reads 
 to long reference sequences. It is particularly good at aligning reads 
 of about 50 up to 100s or 1,000s of characters, and particularly good 
 at aligning to relatively long (e.g. mammalian) genomes. 
 .
 Bowtie 2 indexes the genome with an FM Index to keep its memory footprint
 small: for the human genome, its memory footprint is typically 
 around 3.2 GB. Bowtie 2 supports gapped, local, and paired-end alignment modes
 .
 This package provides some example data to work with bowtie2.

=== debian/rules ===
#!/usr/bin/make -f

pkg=$(shell dpkg-parsechangelog | sed -n 's/^Source: //p')

%:
	dh $@

override_dh_auto_install:
	mkdir -p $(CURDIR)/debian/$(pkg)/usr/share/man/man1/
	help2man --name="wrapper for $(pkg)-align" --no-info \
		$(CURDIR)/$(pkg) > $(CURDIR)/debian/$(pkg)/usr/share/man/man1/$(pkg).1
	help2man --name="building a colorspace index for $(pkg)" --no-info \
		$(CURDIR)/$(pkg)-build > $(CURDIR)/debian/$(pkg)/usr/share/man/man1/$(pkg)-build.1
	help2man --name="extracts information from a $(pkg) index" --no-info \
		$(CURDIR)/$(pkg)-inspect > $(CURDIR)/debian/$(pkg)/usr/share/man/man1/$(pkg)-inspect.1
	help2man --name="ultrafast and memory-efficient tool for aligning sequencing reads to long reference sequences" --no-info \
	    $(CURDIR)/$(pkg)-align> $(CURDIR)/debian/$(pkg)/usr/share/man/man1/$(pkg)-align.1

override_dh_installchangelogs:
	dh_installchangelogs NEWS

get-orig-source:
	. debian/get-orig-source

=== debian/watch ===
version=3

http://sf.net/bowtie-bio/bowtie2-([\d\.]+\-beta\d)\.zip

## bowtie2 2.0.0-beta6

=== debian/changelog ===
bowtie2 (2.0.0-beta6-3) unstable; urgency=low

  * normalized architecture detection.
    For example kfreebsd-amd64 is detected as an amd64 architecture 
    and msse flag is set.(Previous commit was wrong) (Closes: #673159)

 -- Alexandre Mestiashvili <alex@biotec.tu-dresden.de>  Fri, 01 Jun 2012 21:58:49 +0200

bowtie2 (2.0.0-beta6-2) unstable; urgency=low

  * debian/rules normalized output of dpkg-architecture,  
    so for example kfreebsd-amd64 is detected as an amd64 architecture 
    and sse flags are enabled for it.

 -- Alexandre Mestiashvili <alex@biotec.tu-dresden.de>  Thu, 31 May 2012 19:22:56 +0200

bowtie2 (2.0.0-beta6-1) unstable; urgency=low

  * updated debian/watch and get-orig-source to track -source suffix
  * Imported Upstream version 2.0.0-beta6
  * debian/patches/fix_makefile_machine_detection.patch
    use -msse2 only for Intel architectures, Closes: #672526

 -- Alexandre Mestiashvili <alex@biotec.tu-dresden.de>  Fri, 11 May 2012 08:41:59 +0200

bowtie2 (2.0.0-beta5-2) unstable; urgency=low

  [ Alexandre Mestiashvili ]
  * file sse_util.h has missing copyright header. 
    The Author (Benjamin Langmead) has
    confirmed that the file is distributed under GPL3 license.

  [ Andreas Tille ]
  * debian/upstream: Added publication
  * debian/patches/fix_makefile_machine_detection.patch + debian/rules:
    prevent -mXX and -msse2 switches for non Intel architectures

  [ Alexandre Mestiashvili ]
  * debian/patches/bowtie2_gcc4.7.patch Closes: #672090
  * updated DEP3 headers
  * bumperd Standards-Version to 3.9.3
  * uname -m doesn't detect 32 bit chroot env - updated patcH

 -- Andreas Tille <tille@debian.org>  Thu, 26 Apr 2012 13:59:54 +0200

=== debian/control ===
--- 
+++ 
@@ -3,9 +3,10 @@
 Priority: extra
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 DM-Upload-Allowed: yes
-Uploaders: Alexandre Mestiashvili <alex@biotec.tu-dresden.de>
+Uploaders: Alexandre Mestiashvili <alex@biotec.tu-dresden.de>,
+ Andreas Tille <tille@debian.org>
 Build-Depends: debhelper (>= 8.0), help2man
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 Homepage: http://bowtie-bio.sourceforge.net/bowtie2
 Vcs-Browser: http://git.debian.org/?p=debian-med/bowtie2.git
 Vcs-Git: git://git.debian.org/debian-med/bowtie2.git

=== debian/rules ===
--- 
+++ 
@@ -1,9 +1,21 @@
 #!/usr/bin/make -f
 
-pkg=$(shell dpkg-parsechangelog | sed -n 's/^Source: //p')
+pkg := $(shell dpkg-parsechangelog | sed -n 's/^Source: //p')
+arch := $(shell dpkg-architecture -qDEB_HOST_ARCH 2>/dev/null | awk -F- '{print $$NF}')
+
+# ENABLE_SSE=0
+ifeq ($(arch),i386)
+    ENABLE_SSE=1
+endif
+ifeq ($(arch),amd64)
+    ENABLE_SSE=1
+endif
 
 %:
 	dh $@
+
+override_dh_auto_build:
+	dh_auto_build -- ENABLE_SSE=$(ENABLE_SSE)
 
 override_dh_auto_install:
 	mkdir -p $(CURDIR)/debian/$(pkg)/usr/share/man/man1/

=== debian/watch ===
version=3

opts=filenamemangle=s/(.*)(-source)(\..*$)/$1$3/\
	http://sf.net/bowtie-bio/bowtie2-([\d\.]+\-beta\d)\-source\.zip

## bowtie2 2.0.5

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright 2011, Ben Langmead <blangmea@jhsph.edu>
+# Copyright 2011, Ben Langmead <langmea@cs.jhu.edu>
 #
 # This file is part of Bowtie 2.
 #
@@ -76,29 +76,32 @@
 endif
 endif
 
-PREFETCH_LOCALITY = 2
-PREF_DEF = -DPREFETCH_LOCALITY=$(PREFETCH_LOCALITY)
-
 LIBS = 
 SEARCH_LIBS = $(PTHREAD_LIB)
 BUILD_LIBS =
 
 SHARED_CPPS = ccnt_lut.cpp ref_read.cpp alphabet.cpp shmem.cpp \
               edit.cpp bt2_idx.cpp bt2_io.cpp bt2_util.cpp \
-              reference.cpp ds.cpp multikey_qsort.cpp limit.cpp
+              reference.cpp ds.cpp multikey_qsort.cpp limit.cpp \
+			  random_source.cpp
 SEARCH_CPPS = qual.cpp pat.cpp sam.cpp \
               read_qseq.cpp aligner_seed_policy.cpp \
-              aligner_seed.cpp aligner_sw.cpp \
+              aligner_seed.cpp \
+			  aligner_seed2.cpp \
+			  aligner_sw.cpp \
 			  aligner_sw_driver.cpp aligner_cache.cpp \
 			  aligner_result.cpp ref_coord.cpp mask.cpp \
 			  pe.cpp aln_sink.cpp dp_framer.cpp \
 			  scoring.cpp presets.cpp unique.cpp \
+			  simple_func.cpp \
+			  random_util.cpp \
 			  aligner_bt.cpp sse_util.cpp \
 			  aligner_swsse.cpp outq.cpp \
 			  aligner_swsse_loc_i16.cpp \
 			  aligner_swsse_ee_i16.cpp \
 			  aligner_swsse_loc_u8.cpp \
-			  aligner_swsse_ee_u8.cpp
+			  aligner_swsse_ee_u8.cpp \
+			  aligner_driver.cpp
 SEARCH_CPPS_MAIN = $(SEARCH_CPPS) bowtie_main.cpp
 
 BUILD_CPPS = diff_sample.cpp
@@ -149,7 +152,7 @@
                $(PTHREAD_PKG) \
 			   bowtie2 \
                AUTHORS \
-               COPYING \
+               LICENSE \
                NEWS \
                MANUAL \
                MANUAL.markdown \
@@ -302,6 +305,7 @@
 	       --css style.css -o $@ \
 	       --from markdown --to HTML \
 	       --table-of-contents $^
+	rm -f .tmp.head
 
 MANUAL: MANUAL.markdown
 	perl doc/strip_markdown.pl < $^ > $@

=== debian/changelog ===
bowtie2 (2.0.5-1) unstable; urgency=low

  * Imported Upstream version 2.0.5

 -- Alexandre Mestiashvili <alex@biotec.tu-dresden.de>  Fri, 11 Jan 2013 11:19:34 +0100

bowtie2 (2.0.4-1) unstable; urgency=low

  * Imported Upstream version 2.0.4

 -- Alexandre Mestiashvili <alex@biotec.tu-dresden.de>  Thu, 27 Dec 2012 17:33:36 +0100

bowtie2 (2.0.2-1) unstable; urgency=low

  [ Carlos Borroto ]
  * Imported Upstream version 2.0.2
  * bowtie2_gcc4.7.patch no longer needed

  [ Alexandre Mestiashvili ]
  * added autopkgtest testsuite
  * updated Uploaders field

 -- Alexandre Mestiashvili <alex@biotec.tu-dresden.de>  Mon, 19 Nov 2012 16:31:02 +0100

bowtie2 (2.0.0-beta7-1) unstable; urgency=low

  [ Alexandre Mestiashvili ]
  * debian/control force architcures to i386/amd64 kfreebsd-i386/amd64 and 
    hurd-i386 SSE is not availbale on others. Closes: #668123 
  * debhelper version 9
  * debian/rules forced hardening flags
  * hardening.patch to inject hardening CPPFLAGS
  * Imported Upstream version 2.0.0-beta7
  * debian/bowtie2.lintian-overrides to avoid lintian's waring
    to be fixed by using epochs and tilda in upstream version 

 -- Alexandre Mestiashvili <alex@biotec.tu-dresden.de>  Mon, 30 Jul 2012 13:51:31 +0200

=== debian/control ===
--- 
+++ 
@@ -4,15 +4,17 @@
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 DM-Upload-Allowed: yes
 Uploaders: Alexandre Mestiashvili <alex@biotec.tu-dresden.de>,
- Andreas Tille <tille@debian.org>
-Build-Depends: debhelper (>= 8.0), help2man
+ Andreas Tille <tille@debian.org>,
+ Carlos Borroto <carlos.borroto@gmail.com>
+Build-Depends: debhelper (>= 9.0), help2man
 Standards-Version: 3.9.3
+XS-Testsuite: autopkgtest
 Homepage: http://bowtie-bio.sourceforge.net/bowtie2
 Vcs-Browser: http://git.debian.org/?p=debian-med/bowtie2.git
 Vcs-Git: git://git.debian.org/debian-med/bowtie2.git
 
 Package: bowtie2
-Architecture: any
+Architecture: amd64 i386 hurd-i386 kfreebsd-amd64 kfreebsd-i386
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Suggests: bowtie2-examples
 Description: ultrafast memory-efficient short read aligner

=== debian/rules ===
--- 
+++ 
@@ -2,6 +2,11 @@
 
 pkg := $(shell dpkg-parsechangelog | sed -n 's/^Source: //p')
 arch := $(shell dpkg-architecture -qDEB_HOST_ARCH 2>/dev/null | awk -F- '{print $$NF}')
+
+CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS)
+LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)
+EXTRA_FLAGS := $(LDFLAGS)
+
 
 # ENABLE_SSE=0
 ifeq ($(arch),i386)
@@ -15,7 +20,7 @@
 	dh $@
 
 override_dh_auto_build:
-	dh_auto_build -- ENABLE_SSE=$(ENABLE_SSE)
+	dh_auto_build -- ENABLE_SSE=$(ENABLE_SSE) EXTRA_FLAGS=$(EXTRA_FLAGS) CPPFLAGS=$(CPPFLAGS)
 
 override_dh_auto_install:
 	mkdir -p $(CURDIR)/debian/$(pkg)/usr/share/man/man1/

=== debian/tests/control ===
Tests: indexing_ref_genome

## bowtie2 2.1.0

=== Makefile ===
--- 
+++ 
@@ -28,62 +28,69 @@
 CPP = $(GCC_PREFIX)/g++$(GCC_SUFFIX)
 CXX = $(CPP)
 HEADERS = $(wildcard *.h)
-BOWTIE_PTHREADS = 1
 BOWTIE_MM = 1
 BOWTIE_SHARED_MEM = 0
 
 # Detect Cygwin or MinGW
 WINDOWS = 0
+CYGWIN = 0
+MINGW = 0
 ifneq (,$(findstring CYGWIN,$(shell uname)))
-WINDOWS = 1
-# POSIX memory-mapped files not currently supported on Windows
-BOWTIE_MM = 0
-BOWTIE_SHARED_MEM = 0
+	WINDOWS = 1 
+	CYGWIN = 1
+	# POSIX memory-mapped files not currently supported on Windows
+	BOWTIE_MM = 0
+	BOWTIE_SHARED_MEM = 0
 else
-ifneq (,$(findstring MINGW,$(shell uname)))
-WINDOWS = 1
-# POSIX memory-mapped files not currently supported on Windows
-BOWTIE_MM = 0
-BOWTIE_SHARED_MEM = 0
-endif
+	ifneq (,$(findstring MINGW,$(shell uname)))
+		WINDOWS = 1
+		MINGW = 1
+		# POSIX memory-mapped files not currently supported on Windows
+		BOWTIE_MM = 0
+		BOWTIE_SHARED_MEM = 0
+	endif
 endif
 
 MACOS = 0
 ifneq (,$(findstring Darwin,$(shell uname)))
-MACOS = 1
+	MACOS = 1
 endif
 
 MM_DEF = 
+
 ifeq (1,$(BOWTIE_MM))
-MM_DEF = -DBOWTIE_MM
-endif
+	MM_DEF = -DBOWTIE_MM
+endif
+
 SHMEM_DEF = 
+
 ifeq (1,$(BOWTIE_SHARED_MEM))
-SHMEM_DEF = -DBOWTIE_SHARED_MEM
-endif
+	SHMEM_DEF = -DBOWTIE_SHARED_MEM
+endif
+
 PTHREAD_PKG =
-PTHREAD_LIB =
-PTHREAD_DEF =
-ifeq (1,$(BOWTIE_PTHREADS))
-PTHREAD_DEF = -DBOWTIE_PTHREADS
-ifeq (1,$(WINDOWS))
-# pthreads for windows forces us to be specific about the library
-PTHREAD_LIB = -lpthreadGC2
-PTHREAD_PKG = pthreadGC2.dll
+PTHREAD_LIB = 
+
+ifeq (1,$(MINGW))
+	PTHREAD_LIB = 
 else
-# There's also -pthread, but that only seems to work on Linux
-PTHREAD_LIB = -lpthread
-endif
-endif
-
-LIBS = 
-SEARCH_LIBS = $(PTHREAD_LIB)
-BUILD_LIBS =
+	PTHREAD_LIB = -lpthread
+endif
+
+LIBS = $(PTHREAD_LIB)
+SEARCH_LIBS = 
+BUILD_LIBS = 
+INSPECT_LIBS =
+
+ifeq (1,$(MINGW))
+	BUILD_LIBS = 
+	INSPECT_LIBS = 
+endif
 
 SHARED_CPPS = ccnt_lut.cpp ref_read.cpp alphabet.cpp shmem.cpp \
               edit.cpp bt2_idx.cpp bt2_io.cpp bt2_util.cpp \
               reference.cpp ds.cpp multikey_qsort.cpp limit.cpp \
-			  random_source.cpp
+			  random_source.cpp tinythread.cpp
 SEARCH_CPPS = qual.cpp pat.cpp sam.cpp \
               read_qseq.cpp aligner_seed_policy.cpp \
               aligner_seed.cpp \
@@ -109,21 +116,27 @@
 
 SEARCH_FRAGMENTS = $(wildcard search_*_phase*.c)
 VERSION = $(shell cat VERSION)
-EXTRA_FLAGS =
 
 # Convert BITS=?? to a -m flag
 BITS=32
 ifeq (x86_64,$(shell uname -m))
 BITS=64
 endif
+# msys will always be 32 bit so look at the cpu arch instead.
+ifneq (,$(findstring AMD64,$(PROCESSOR_ARCHITEW6432)))
+	ifeq (1,$(MINGW))
+		BITS=64
+	endif
+endif
 BITS_FLAG =
+
 ifeq (32,$(BITS))
-BITS_FLAG = -m32
-endif
+	BITS_FLAG = -m32
+endif
+
 ifeq (64,$(BITS))
-BITS_FLAG = -m64
-endif
-
+	BITS_FLAG = -m64
+endif
 SSE_FLAG=-msse2
 
 DEBUG_FLAGS    = -O0 -g3 $(BITS_FLAG) $(SSE_FLAG)
@@ -189,7 +202,6 @@
      -DBUILD_TIME="\"`date`\"" \
      -DCOMPILER_VERSION="\"`$(CXX) -v 2>&1 | tail -1`\"" \
      $(FILE_FLAGS) \
-     $(PTHREAD_DEF) \
      $(PREF_DEF) \
      $(MM_DEF) \
      $(SHMEM_DEF)
@@ -205,7 +217,7 @@
 		-o $@ $< \
 		$(SHARED_CPPS) $(BUILD_CPPS_MAIN) \
 		$(LIBS) $(BUILD_LIBS)
-
+        
 bowtie2-build-debug: bt2_build.cpp $(SHARED_CPPS) $(HEADERS)
 	$(CXX) $(DEBUG_FLAGS) $(DEBUG_DEFS) $(EXTRA_FLAGS) \
 		$(DEFS) -DBOWTIE2 -Wall \
@@ -246,7 +258,7 @@
 		$(INC) -I . \
 		-o $@ $< \
 		$(SHARED_CPPS) \
-		$(LIBS)
+		$(LIBS) $(INSPECT_LIBS)
 
 bowtie2-inspect-debug: bt2_inspect.cpp $(HEADERS) $(SHARED_CPPS) 
 	$(CXX) $(DEBUG_FLAGS) \
@@ -255,7 +267,7 @@
 		$(INC) -I . \
 		-o $@ $< \
 		$(SHARED_CPPS) \
-		$(LIBS)
+		$(LIBS) $(INSPECT_LIBS)
 
 .PHONY: bowtie2-src
 bowtie2-src: $(SRC_PKG_LIST)

=== debian/changelog ===
bowtie2 (2.1.0-2) unstable; urgency=low

  * Closes: #713000 
  * d/control: fixed description for bowtie2-examples,
     bumped Standards-Version,
     removed DM-Upload-Allowed,
     use canonical vcs
  * d/tests/: underscore are not allowed for tests

 -- Alexandre Mestiashvili <alex@biotec.tu-dresden.de>  Tue, 25 Jun 2013 13:58:18 +0200

bowtie2 (2.1.0-1) unstable; urgency=low

  * - d/help2man-wrapper: as kindly suggested by Andreas Tille 
    Closes: #701686
    - d/rules: use help2man-wrapper instead of help2man to generate man pages
  * Imported Upstream version 2.1.0
  * refreshed patches

 -- Alexandre Mestiashvili <alex@biotec.tu-dresden.de>  Wed, 27 Feb 2013 15:58:40 +0100

bowtie2 (2.0.6-1) unstable; urgency=low

  * Imported Upstream version 2.0.6

 -- Alexandre Mestiashvili <alex@biotec.tu-dresden.de>  Tue, 19 Feb 2013 17:30:42 +0100

=== debian/control ===
--- 
+++ 
@@ -2,16 +2,15 @@
 Section: science
 Priority: extra
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-DM-Upload-Allowed: yes
 Uploaders: Alexandre Mestiashvili <alex@biotec.tu-dresden.de>,
  Andreas Tille <tille@debian.org>,
  Carlos Borroto <carlos.borroto@gmail.com>
 Build-Depends: debhelper (>= 9.0), help2man
-Standards-Version: 3.9.3
+Standards-Version: 3.9.4
 XS-Testsuite: autopkgtest
 Homepage: http://bowtie-bio.sourceforge.net/bowtie2
-Vcs-Browser: http://git.debian.org/?p=debian-med/bowtie2.git
-Vcs-Git: git://git.debian.org/debian-med/bowtie2.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-med/bowtie2.git
+Vcs-Git: git://anonscm.debian.org/debian-med/bowtie2.git
 
 Package: bowtie2
 Architecture: amd64 i386 hurd-i386 kfreebsd-amd64 kfreebsd-i386
@@ -32,8 +31,8 @@
 Depends: ${misc:Depends}
 Recommends: bowtie2
 Enhances: bowtie2
-Description: Examples for bowtie2, 
- an ultrafast and memory-efficient tool for aligning sequencing reads 
+Description: Examples for bowtie2
+ An ultrafast and memory-efficient tool for aligning sequencing reads 
  to long reference sequences. It is particularly good at aligning reads 
  of about 50 up to 100s or 1,000s of characters, and particularly good 
  at aligning to relatively long (e.g. mammalian) genomes.

=== debian/rules ===
#!/usr/bin/make -f

pkg := $(shell dpkg-parsechangelog | sed -n 's/^Source: //p')
arch := $(shell dpkg-architecture -qDEB_HOST_ARCH 2>/dev/null | awk -F- '{print $$NF}')

CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS)
LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)
EXTRA_FLAGS := $(LDFLAGS)


# ENABLE_SSE=0
ifeq ($(arch),i386)
    ENABLE_SSE=1
endif
ifeq ($(arch),amd64)
    ENABLE_SSE=1
endif

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- ENABLE_SSE=$(ENABLE_SSE) EXTRA_FLAGS=$(EXTRA_FLAGS) CPPFLAGS=$(CPPFLAGS)

override_dh_installman:
	mkdir -p $(CURDIR)/debian/$(pkg)/usr/share/man/man1/
	debian/help2man-wrapper $(pkg) "wrapper for $(pkg)-align"
	debian/help2man-wrapper $(pkg)-build "building a colorspace index for $(pkg)"
	debian/help2man-wrapper $(pkg)-inspect "extracts information from a $(pkg) index"
	debian/help2man-wrapper $(pkg)-align "ultrafast and memory-efficient tool for aligning sequencing reads to long reference sequences"

override_dh_installchangelogs:
	dh_installchangelogs NEWS

get-orig-source:
	. debian/get-orig-source

=== debian/tests/control ===
Tests: indexing-ref-genome

=== debian/watch ===
version=3

opts=filenamemangle=s/(.*)(-source)(\..*$)/$1$3/\
	http://sf.net/bowtie-bio/bowtie2-([\d\.]+)\-source\.zip

## bowtie2 2.2.4

=== Makefile ===
--- 
+++ 
@@ -54,6 +54,18 @@
 MACOS = 0
 ifneq (,$(findstring Darwin,$(shell uname)))
 	MACOS = 1
+endif
+
+ifneq (,$(findstring 13,$(shell uname -r)))
+	CPP = clang++
+	CC = clang
+	EXTRA_FLAGS += -stdlib=libstdc++
+endif
+
+POPCNT_CAPABILITY ?= 1
+ifeq (1, $(POPCNT_CAPABILITY))
+    EXTRA_FLAGS += -DPOPCNT_CAPABILITY
+    INC += -I third_party
 endif
 
 MM_DEF = 
@@ -111,16 +123,20 @@
 			  aligner_driver.cpp
 SEARCH_CPPS_MAIN = $(SEARCH_CPPS) bowtie_main.cpp
 
+DP_CPPS = qual.cpp aligner_sw.cpp aligner_result.cpp ref_coord.cpp mask.cpp \
+          simple_func.cpp sse_util.cpp aligner_bt.cpp aligner_swsse.cpp \
+		  aligner_swsse_loc_i16.cpp aligner_swsse_ee_i16.cpp \
+		  aligner_swsse_loc_u8.cpp aligner_swsse_ee_u8.cpp scoring.cpp
+
 BUILD_CPPS = diff_sample.cpp
 BUILD_CPPS_MAIN = $(BUILD_CPPS) bowtie_build_main.cpp
 
 SEARCH_FRAGMENTS = $(wildcard search_*_phase*.c)
 VERSION = $(shell cat VERSION)
 
-# Convert BITS=?? to a -m flag
 BITS=32
 ifeq (x86_64,$(shell uname -m))
-BITS=64
+	BITS=64
 endif
 # msys will always be 32 bit so look at the cpu arch instead.
 ifneq (,$(findstring AMD64,$(PROCESSOR_ARCHITEW6432)))
@@ -128,30 +144,31 @@
 		BITS=64
 	endif
 endif
-BITS_FLAG =
-
 ifeq (32,$(BITS))
-	BITS_FLAG = -m32
-endif
-
-ifeq (64,$(BITS))
-	BITS_FLAG = -m64
-endif
-SSE_FLAG=-msse2
-
-DEBUG_FLAGS    = -O0 -g3 $(BITS_FLAG) $(SSE_FLAG)
+  $(error bowtie2 compilation requires a 64-bit platform )
+endif
+
+SSE_FLAG=-msse2 
+
+DEBUG_FLAGS    = -O0 -g3 -m64 $(SSE_FLAG)
 DEBUG_DEFS     = -DCOMPILER_OPTIONS="\"$(DEBUG_FLAGS) $(EXTRA_FLAGS)\""
-RELEASE_FLAGS  = -O3 $(BITS_FLAG) $(SSE_FLAG) -funroll-loops -g3
+RELEASE_FLAGS  = -O3 -m64 $(SSE_FLAG) -funroll-loops -g3
 RELEASE_DEFS   = -DCOMPILER_OPTIONS="\"$(RELEASE_FLAGS) $(EXTRA_FLAGS)\""
 NOASSERT_FLAGS = -DNDEBUG
 FILE_FLAGS     = -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64 -D_GNU_SOURCE
 
-BOWTIE2_BIN_LIST =     bowtie2-build \
-                       bowtie2-align \
-                       bowtie2-inspect
-BOWTIE2_BIN_LIST_AUX = bowtie2-build-debug \
-                       bowtie2-align-debug \
-                       bowtie2-inspect-debug
+BOWTIE2_BIN_LIST =     bowtie2-build-s \
+                       bowtie2-build-l \
+                       bowtie2-align-s \
+                       bowtie2-align-l \
+                       bowtie2-inspect-s \
+                       bowtie2-inspect-l
+BOWTIE2_BIN_LIST_AUX = bowtie2-build-s-debug \
+                       bowtie2-build-l-debug \
+                       bowtie2-align-s-debug \
+                       bowtie2-align-l-debug \
+                       bowtie2-inspect-s-debug \
+                       bowtie2-inspect-l-debug
 
 GENERAL_LIST = $(wildcard scripts/*.sh) \
                $(wildcard scripts/*.pl) \
@@ -164,6 +181,8 @@
 			   example/reference/lambda_virus.fa \
                $(PTHREAD_PKG) \
 			   bowtie2 \
+			   bowtie2-build \
+			   bowtie2-inspect \
                AUTHORS \
                LICENSE \
                NEWS \
@@ -172,6 +191,11 @@
                TUTORIAL \
                VERSION
 
+ifeq (1,$(WINDOWS))
+	BOWTIE2_BIN_LIST := $(BOWTIE2_BIN_LIST) bowtie2.bat bowtie2-build.bat bowtie2-inspect.bat 
+	EXTRA_FLAGS += -static-libgcc -static-libstdc++
+endif
+
 # This is helpful on Windows under MinGW/MSYS, where Make might go for
 # the Windows FIND tool instead.
 FIND=$(shell which find)
@@ -180,11 +204,16 @@
                $(wildcard *.hh) \
                $(wildcard *.c) \
                $(wildcard *.cpp) \
+               $(wildcard third_party/*) \
                doc/strip_markdown.pl \
                Makefile \
                $(GENERAL_LIST)
 
-BIN_PKG_LIST = $(GENERAL_LIST)
+ifeq (1,$(WINDOWS))
+	BIN_PKG_LIST = $(GENERAL_LIST) bowtie2.bat bowtie2-build.bat bowtie2-inspect.bat 
+else
+	BIN_PKG_LIST = $(GENERAL_LIST)
+endif
 
 .PHONY: all allall both both-debug
 
@@ -192,9 +221,9 @@
 
 allall: $(BOWTIE2_BIN_LIST) $(BOWTIE2_BIN_LIST_AUX)
 
-both: bowtie2 bowtie2-build
-
-both-debug: bowtie2-align-debug bowtie2-build-debug
+both: bowtie2-align-s bowtie2-build-s bowtie2-align-l bowtie2-build-l
+
+both-debug: bowtie2-align-s-debug bowtie2-build-s-debug bowtie2-align-l-debug bowtie2-build-l-debug
 
 DEFS=-fno-strict-aliasing \
      -DBOWTIE2_VERSION="\"`cat VERSION`\"" \
@@ -210,15 +239,23 @@
 # bowtie2-build targets
 #
 
-bowtie2-build: bt2_build.cpp $(SHARED_CPPS) $(HEADERS)
+bowtie2-build-s: bt2_build.cpp $(SHARED_CPPS) $(HEADERS)
 	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(EXTRA_FLAGS) \
 		$(DEFS) -DBOWTIE2 $(NOASSERT_FLAGS) -Wall \
 		$(INC) \
 		-o $@ $< \
 		$(SHARED_CPPS) $(BUILD_CPPS_MAIN) \
 		$(LIBS) $(BUILD_LIBS)
-        
-bowtie2-build-debug: bt2_build.cpp $(SHARED_CPPS) $(HEADERS)
+
+bowtie2-build-l: bt2_build.cpp $(SHARED_CPPS) $(HEADERS)
+	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(EXTRA_FLAGS) \
+		$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX $(NOASSERT_FLAGS) -Wall \
+		$(INC) \
+		-o $@ $< \
+		$(SHARED_CPPS) $(BUILD_CPPS_MAIN) \
+		$(LIBS) $(BUILD_LIBS)
+
+bowtie2-build-s-debug: bt2_build.cpp $(SHARED_CPPS) $(HEADERS)
 	$(CXX) $(DEBUG_FLAGS) $(DEBUG_DEFS) $(EXTRA_FLAGS) \
 		$(DEFS) -DBOWTIE2 -Wall \
 		$(INC) \
@@ -226,11 +263,19 @@
 		$(SHARED_CPPS) $(BUILD_CPPS_MAIN) \
 		$(LIBS) $(BUILD_LIBS)
 
-#
-# bowtie targets
-#
-
-bowtie2-align: bt2_search.cpp $(SEARCH_CPPS) $(SHARED_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
+bowtie2-build-l-debug: bt2_build.cpp $(SHARED_CPPS) $(HEADERS)
+	$(CXX) $(DEBUG_FLAGS) $(DEBUG_DEFS) $(EXTRA_FLAGS) \
+		$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX -Wall \
+		$(INC) \
+		-o $@ $< \
+		$(SHARED_CPPS) $(BUILD_CPPS_MAIN) \
+		$(LIBS) $(BUILD_LIBS)
+
+#
+# bowtie2-align targets
+#
+
+bowtie2-align-s: bt2_search.cpp $(SEARCH_CPPS) $(SHARED_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
 	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(EXTRA_FLAGS) \
 		$(DEFS) -DBOWTIE2 $(NOASSERT_FLAGS) -Wall \
 		$(INC) \
@@ -238,7 +283,15 @@
 		$(SHARED_CPPS) $(SEARCH_CPPS_MAIN) \
 		$(LIBS) $(SEARCH_LIBS)
 
-bowtie2-align-debug: bt2_search.cpp $(SEARCH_CPPS) $(SHARED_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
+bowtie2-align-l: bt2_search.cpp $(SEARCH_CPPS) $(SHARED_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
+	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(EXTRA_FLAGS) \
+		$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX $(NOASSERT_FLAGS) -Wall \
+		$(INC) \
+		-o $@ $< \
+		$(SHARED_CPPS) $(SEARCH_CPPS_MAIN) \
+		$(LIBS) $(SEARCH_LIBS)
+
+bowtie2-align-s-debug: bt2_search.cpp $(SEARCH_CPPS) $(SHARED_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
 	$(CXX) $(DEBUG_FLAGS) \
 		$(DEBUG_DEFS) $(EXTRA_FLAGS) \
 		$(DEFS) -DBOWTIE2 -Wall \
@@ -247,11 +300,20 @@
 		$(SHARED_CPPS) $(SEARCH_CPPS_MAIN) \
 		$(LIBS) $(SEARCH_LIBS)
 
+bowtie2-align-l-debug: bt2_search.cpp $(SEARCH_CPPS) $(SHARED_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
+	$(CXX) $(DEBUG_FLAGS) \
+		$(DEBUG_DEFS) $(EXTRA_FLAGS) \
+		$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX -Wall \
+		$(INC) \
+		-o $@ $< \
+		$(SHARED_CPPS) $(SEARCH_CPPS_MAIN) \
+		$(LIBS) $(SEARCH_LIBS)
+
 #
 # bowtie2-inspect targets
 #
 
-bowtie2-inspect: bt2_inspect.cpp $(HEADERS) $(SHARED_CPPS)
+bowtie2-inspect-s: bt2_inspect.cpp $(HEADERS) $(SHARED_CPPS)
 	$(CXX) $(RELEASE_FLAGS) \
 		$(RELEASE_DEFS) $(EXTRA_FLAGS) \
 		$(DEFS) -DBOWTIE2 -DBOWTIE_INSPECT_MAIN -Wall \
@@ -260,14 +322,66 @@
 		$(SHARED_CPPS) \
 		$(LIBS) $(INSPECT_LIBS)
 
-bowtie2-inspect-debug: bt2_inspect.cpp $(HEADERS) $(SHARED_CPPS) 
-	$(CXX) $(DEBUG_FLAGS) \
-		$(DEBUG_DEFS) $(EXTRA_FLAGS) \
-		$(DEFS) -DBOWTIE2 -DBOWTIE_INSPECT_MAIN -Wall \
+bowtie2-inspect-l: bt2_inspect.cpp $(HEADERS) $(SHARED_CPPS)
+	$(CXX) $(RELEASE_FLAGS) \
+		$(RELEASE_DEFS) $(EXTRA_FLAGS) \
+		$(DEFS) -DBOWTIE2 -DBOWTIE_INSPECT_MAIN  -DBOWTIE_64BIT_INDEX -Wall \
 		$(INC) -I . \
 		-o $@ $< \
 		$(SHARED_CPPS) \
 		$(LIBS) $(INSPECT_LIBS)
+
+bowtie2-inspect-s-debug: bt2_inspect.cpp $(HEADERS) $(SHARED_CPPS) 
+	$(CXX) $(DEBUG_FLAGS) \
+		$(DEBUG_DEFS) $(EXTRA_FLAGS) \
+		$(DEFS) -DBOWTIE2 -DBOWTIE_INSPECT_MAIN -Wall \
+		$(INC) -I . \
+		-o $@ $< \
+		$(SHARED_CPPS) \
+		$(LIBS) $(INSPECT_LIBS)
+
+bowtie2-inspect-l-debug: bt2_inspect.cpp $(HEADERS) $(SHARED_CPPS)
+	$(CXX) $(DEBUG_FLAGS) \
+		$(DEBUG_DEFS) $(EXTRA_FLAGS) \
+		$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX -DBOWTIE_INSPECT_MAIN -Wall \
+		$(INC) -I . \
+		-o $@ $< \
+		$(SHARED_CPPS) \
+		$(LIBS) $(INSPECT_LIBS)
+
+#
+# bowtie2-dp targets
+#
+
+bowtie2-dp: bt2_dp.cpp $(HEADERS) $(SHARED_CPPS) $(DP_CPPS)
+	$(CXX) $(RELEASE_FLAGS) \
+		$(RELEASE_DEFS) $(EXTRA_FLAGS) $(NOASSERT_FLAGS) \
+		$(DEFS) -DBOWTIE2 -DBOWTIE_DP_MAIN -Wall \
+		$(INC) -I . \
+		-o $@ $< \
+		$(DP_CPPS) $(SHARED_CPPS) \
+		$(LIBS) $(SEARCH_LIBS)
+
+bowtie2-dp-debug: bt2_dp.cpp $(HEADERS) $(SHARED_CPPS) $(DP_CPPS)
+	$(CXX) $(DEBUG_FLAGS) \
+		$(DEBUG_DEFS) $(EXTRA_FLAGS) \
+		$(DEFS) -DBOWTIE2 -DBOWTIE_DP_MAIN -Wall \
+		$(INC) -I . \
+		-o $@ $< \
+		$(DP_CPPS) $(SHARED_CPPS) \
+		$(LIBS) $(SEARCH_LIBS)
+
+bowtie2.bat:
+	echo "@echo off" > bowtie2.bat
+	echo "perl %~dp0/bowtie2 %*" >> bowtie2.bat
+
+bowtie2-build.bat:
+	echo "@echo off" > bowtie2-build.bat
+	echo "python %~dp0/bowtie2-build %*" >> bowtie2-build.bat
+
+bowtie2-inspect.bat:
+	echo "@echo off" > bowtie2-inspect.bat
+	echo "python %~dp0/bowtie2-inspect %*" >> bowtie2-inspect.bat
 
 .PHONY: bowtie2-src
 bowtie2-src: $(SRC_PKG_LIST)
@@ -287,15 +401,15 @@
 	rm -rf .bin.tmp
 	mkdir .bin.tmp
 	mkdir .bin.tmp/bowtie2-$(VERSION)
-	if [ -f bowtie.exe ] ; then \
+	if [ -f bowtie2-align-s.exe ] ; then \
 		zip tmp.zip $(BIN_PKG_LIST) $(addsuffix .exe,$(BOWTIE2_BIN_LIST) $(BOWTIE2_BIN_LIST_AUX)) ; \
 	else \
 		zip tmp.zip $(BIN_PKG_LIST) $(BOWTIE2_BIN_LIST) $(BOWTIE2_BIN_LIST_AUX) ; \
 	fi
 	mv tmp.zip .bin.tmp/bowtie2-$(VERSION)
 	cd .bin.tmp/bowtie2-$(VERSION) ; unzip tmp.zip ; rm -f tmp.zip
-	cd .bin.tmp ; zip -r bowtie2-$(VERSION)-$(BITS).zip bowtie2-$(VERSION)
-	cp .bin.tmp/bowtie2-$(VERSION)-$(BITS).zip .
+	cd .bin.tmp ; zip -r bowtie2-$(VERSION).zip bowtie2-$(VERSION)
+	cp .bin.tmp/bowtie2-$(VERSION).zip .
 	rm -rf .bin.tmp
 
 bowtie2-seeds-debug: aligner_seed.cpp ccnt_lut.cpp alphabet.cpp aligner_seed.h bt2_idx.cpp bt2_io.cpp
@@ -305,27 +419,3 @@
 		$(DEFS) -Wall \
 		$(INC) -I . \
 		-o $@ $< \
-		aligner_seed.cpp bt2_idx.cpp ccnt_lut.cpp alphabet.cpp bt2_io.cpp \
-		$(LIBS)
-
-.PHONY: doc
-doc: doc/manual.html MANUAL
-
-doc/manual.html: MANUAL.markdown
-	echo "<h1>Table of Contents</h1>" > .tmp.head
-	pandoc -T "Bowtie 2 Manual" -B .tmp.head \
-	       --css style.css -o $@ \
-	       --from markdown --to HTML \
-	       --table-of-contents $^
-	rm -f .tmp.head
-
-MANUAL: MANUAL.markdown
-	perl doc/strip_markdown.pl < $^ > $@
-
-.PHONY: clean
-clean:
-	rm -f $(BOWTIE2_BIN_LIST) $(BOWTIE2_BIN_LIST_AUX) \
-	$(addsuffix .exe,$(BOWTIE2_BIN_LIST) $(BOWTIE2_BIN_LIST_AUX)) \
-	bowtie2-src.zip bowtie2-bin.zip
-	rm -f core.* .tmp.head
-	rm -rf *.dSYM

=== debian/changelog ===
bowtie2 (2.2.4-1) unstable; urgency=medium

  [ Andreas Tille ]
  * d/control: Priority: optional
  * add missing DEP3 description

  [ Alexandre Mestiashvili ]
  * d/test/binary-run: test that binary work 
  * d/test/control: add binary-run

  [ Andreas Tille ]
  * New upstream version
  * do uscan call directly in debian/rules instead of separate script
  * cme fix dpkg-control

 -- Andreas Tille <tille@debian.org>  Sun, 26 Oct 2014 07:08:46 +0100

bowtie2 (2.2.3-1) unstable; urgency=medium

  * Imported Upstream version 2.2.3

 -- Alexandre Mestiashvili <alex@biotec.tu-dresden.de>  Tue, 03 Jun 2014 16:13:47 +0200

bowtie2 (2.2.2-1) unstable; urgency=medium

  * Imported Upstream version 2.2.2

 -- Alexandre Mestiashvili <alex@biotec.tu-dresden.de>  Tue, 15 Apr 2014 13:40:01 +0200

bowtie2 (2.2.1-1) unstable; urgency=medium

  * Imported Upstream version 2.2.1
  * d/changelog: updated Copyright years

 -- Alexandre Mestiashvili <alex@biotec.tu-dresden.de>  Fri, 07 Mar 2014 09:37:13 +0100

bowtie2 (2.2.0-1) unstable; urgency=medium

  [ Alexandre Mestiashvili ]
  * Imported Upstream version 2.2.0

  [ James McCoy ]
  * Move debian/upstream to debian/upstream/metadata

  [ Alexandre Mestiashvili ]
  * refreshed patches, dropped fix_makefile_machine_detection.patch
  * d/control: bump Standards-Version
    Architecture: amd64 kfreebsd-amd64, starting from this version
    bowtie2 works on amd64 only
    added python to Depends:  
  * d/rules: remove i386 related fixes,rules for new binaries  
  * d/bowtie2.install: added new binaries introduced by the new version  

 -- Alexandre Mestiashvili <alex@biotec.tu-dresden.de>  Thu, 20 Feb 2014 13:29:58 +0100

=== debian/control ===
--- 
+++ 
@@ -1,20 +1,23 @@
 Source: bowtie2
-Section: science
-Priority: extra
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Alexandre Mestiashvili <alex@biotec.tu-dresden.de>,
- Andreas Tille <tille@debian.org>,
- Carlos Borroto <carlos.borroto@gmail.com>
-Build-Depends: debhelper (>= 9.0), help2man
-Standards-Version: 3.9.4
-XS-Testsuite: autopkgtest
+           Andreas Tille <tille@debian.org>,
+           Carlos Borroto <carlos.borroto@gmail.com>
+Section: science
+Testsuite: autopkgtest
+Priority: optional
+Build-Depends: debhelper (>= 9.0),
+               help2man
+Standards-Version: 3.9.6
+Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/bowtie2.git
+Vcs-Git: git://anonscm.debian.org/debian-med/bowtie2.git
 Homepage: http://bowtie-bio.sourceforge.net/bowtie2
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-med/bowtie2.git
-Vcs-Git: git://anonscm.debian.org/debian-med/bowtie2.git
 
 Package: bowtie2
-Architecture: amd64 i386 hurd-i386 kfreebsd-amd64 kfreebsd-i386
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Architecture: amd64 kfreebsd-amd64
+Depends: ${shlibs:Depends},
+         ${misc:Depends},
+         python
 Suggests: bowtie2-examples
 Description: ultrafast memory-efficient short read aligner
  is an ultrafast and memory-efficient tool for aligning sequencing reads

=== debian/rules ===
#!/usr/bin/make -f

pkg := $(shell dpkg-parsechangelog | sed -n 's/^Source: //p')

CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS)
LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)
EXTRA_FLAGS := $(LDFLAGS)

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- EXTRA_FLAGS=$(EXTRA_FLAGS) CPPFLAGS=$(CPPFLAGS)

override_dh_installman:
	mkdir -p $(CURDIR)/debian/$(pkg)/usr/share/man/man1/
	debian/help2man-wrapper $(pkg) "wrapper for $(pkg)-align-*"
	debian/help2man-wrapper $(pkg)-build "wrapper for $(pkg)-build-*"
	debian/help2man-wrapper $(pkg)-build-l "building a colorspace index for $(pkg)"
	debian/help2man-wrapper $(pkg)-build-s "building a colorspace index for $(pkg)"
	debian/help2man-wrapper $(pkg)-inspect "wrapper for $(pkg)-inspect-* index"
	debian/help2man-wrapper $(pkg)-inspect-l "extracts information from a $(pkg) index"
	debian/help2man-wrapper $(pkg)-inspect-s "extracts information from a $(pkg) index"
	debian/help2man-wrapper $(pkg)-align-l "ultrafast and memory-efficient backend tool for aligning sequencing reads to long reference sequences"
	debian/help2man-wrapper $(pkg)-align-s "ultrafast and memory-efficient backend tool for aligning sequencing reads to long reference sequences"

override_dh_installchangelogs:
	dh_installchangelogs NEWS

get-orig-source:
	mkdir -p ../tarballs
	uscan --verbose --force-download --repack --compress xz --destdir ../tarballs

## bowtie2 2.2.5

=== Makefile ===
--- 
+++ 
@@ -54,12 +54,11 @@
 MACOS = 0
 ifneq (,$(findstring Darwin,$(shell uname)))
 	MACOS = 1
-endif
-
-ifneq (,$(findstring 13,$(shell uname -r)))
-	CPP = clang++
-	CC = clang
-	EXTRA_FLAGS += -stdlib=libstdc++
+	ifneq (,$(findstring 13,$(shell uname -r)))
+		CPP = clang++
+		CC = clang
+		EXTRA_FLAGS += -stdlib=libstdc++
+	endif
 endif
 
 POPCNT_CAPABILITY ?= 1

=== debian/changelog ===
bowtie2 (2.2.5-2) unstable; urgency=medium

  * Upload to unstable

 -- Alexandre Mestiashvili <alex@biotec.tu-dresden.de>  Tue, 28 Apr 2015 18:06:34 +0200

bowtie2 (2.2.5-1) experimental; urgency=medium

  * Imported Upstream version 2.2.5

 -- Alexandre Mestiashvili <alex@biotec.tu-dresden.de>  Wed, 18 Mar 2015 10:09:35 +0100

bowtie2 (2.2.4-2) unstable; urgency=medium

  * d/control: add python dependency, needed to build bowtie2-build man page
    Closes: #769934
  * d/watch: fix upstream url parsing, see #766878
  * d/rules: remove byte-compiled bowtie2-buildc

 -- Alexandre Mestiashvili <alex@biotec.tu-dresden.de>  Tue, 18 Nov 2014 23:28:33 +0100

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,8 @@
 Testsuite: autopkgtest
 Priority: optional
 Build-Depends: debhelper (>= 9.0),
-               help2man
+               help2man,
+               python
 Standards-Version: 3.9.6
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/bowtie2.git
 Vcs-Git: git://anonscm.debian.org/debian-med/bowtie2.git

=== debian/rules ===
--- 
+++ 
@@ -23,6 +23,7 @@
 	debian/help2man-wrapper $(pkg)-inspect-s "extracts information from a $(pkg) index"
 	debian/help2man-wrapper $(pkg)-align-l "ultrafast and memory-efficient backend tool for aligning sequencing reads to long reference sequences"
 	debian/help2man-wrapper $(pkg)-align-s "ultrafast and memory-efficient backend tool for aligning sequencing reads to long reference sequences"
+	rm -f $(CURDIR)/debian/$(pkg)/usr/bin/bowtie2-buildc
 
 override_dh_installchangelogs:
 	dh_installchangelogs NEWS
